package com.asda.android.analytics

import com.asda.android.abtestingframework.implementation.sitespect.SiteSpectHelper
import com.asda.android.analytics.AnalyticsConfig.siteSpectIds
import com.asda.android.app.main.AsdaApplication
import com.asda.android.authorization.BootstrapManager
import com.asda.android.restapi.config.ISiteSpectManager

class SiteSpectManager : ISiteSpectManager {
    override fun onSiteSpectIdUpdate() {
        val siteSpectAnalyticList = AsdaApplication.getComponent()?.sitespectAbTestEngine?.siteSpectList
        val siteSpectHelper = SiteSpectHelper()
        val siteSpectIdsFromSiteConfig = siteSpectHelper.convertSiteSpectIdsToList(BootstrapManager.getExperimentConfig().ssWatts)
        val siteSpecIds = siteSpectHelper.mergeSiteSpectIds(siteSpectAnalyticList, siteSpectIdsFromSiteConfig)
        siteSpectIds = siteSpecIds
    }
}
