package com.asda.android.app.account.address.view

import com.asda.android.app.home.view.RegisterHelper
import com.asda.android.restapi.service.data.AddressBookResponse
import com.asda.android.restapi.service.data.PostcodeCheckResponse
import com.asda.android.singleprofile.features.account.view.BaseAddEditAddressFragment
import com.asda.android.singleprofile.features.account.view.SPAddressesFragment
import com.asda.android.singleprofile.interfaces.AddressBookChangedListener
import com.asda.android.singleprofile.interfaces.ISingleProfileHelper
import com.asda.android.utils.Utils

class SingleProfileHelper : ISingleProfileHelper {
    override fun dontDeliver(data: PostcodeCheckResponse?): Boolean {
        return RegisterHelper.dontDeliver(data)
    }
    override fun dontDeliverSP(data: PostcodeCheckResponse?): Boolean {
        return RegisterHelper.dontDeliverSP(data)
    }
    override fun setPostcodeNotFoundMessage(message: String?) {
        BaseAddEditAddressFragment.setPostcodeNotFoundMessage(message)
    }
    override fun getUserEmail(): String? {
        return Utils.userEmail
    }
    override fun lunchAddAddressFragment(addressSuggestions: Array<PostcodeCheckResponse.AddressSuggestion?>?, postcode: String, mainAddress: AddressBookResponse.Address?, fragment: SPAddressesFragment, listener: AddressBookChangedListener) {
        val addressFragment: BaseAddEditAddressFragment = BaseAddEditAddressFragment.getAddAddressFragment(
            postcode, true, mainAddress, addressSuggestions, null, null, null, true,
            false,
            AddressBookResponse.Type.ShipTo.toString(),
            false
        )
        addressFragment.setAddressBookChangedListener(listener)
        fragment.push(addressFragment)
    }

    override fun lunchEditAddressFragment(address: AddressBookResponse.Address, postcode: String, fragment: SPAddressesFragment, listener: AddressBookChangedListener) {
        val editAddressFragment = BaseAddEditAddressFragment.getEditAddressFragment(address, postcode, AddressBookResponse.Type.ShipTo.toString())
        editAddressFragment.setAddressBookChangedListener(listener)
        fragment.push(editAddressFragment)
    }
}
