package com.asda.android.app.checkout

import androidx.appcompat.app.AppCompatActivity
import com.asda.android.app.account.singleprofile.view.SPAddEditPaymentCardFragment
import com.asda.android.app.account.singleprofile.view.SPAddEditPaymentCardFragment.Companion.newInstance
import com.asda.android.app.view.WrapperPresenter
import com.asda.android.base.interfaces.IBaseFragment
import com.asda.android.base.interfaces.TransitionListener

class AddCardWrapperPresenter(activity: AppCompatActivity, listener: SPAddEditPaymentCardFragment.OnCXOCardAddedListener?) : WrapperPresenter(activity) {

    init {
        val addEditPaymentCardFragment = newInstance(
            null, true, true, SPAddEditPaymentCardFragment.PURCHASE_TYPE_BASKET
        )
        addEditPaymentCardFragment.transitionListener = object : TransitionListener {
            override fun onPushed(newFragment: IBaseFragment, addToBackStack: Boolean): Boolean {
                return false
            }

            override fun onPopped(tag: String?): Boolean {
                if (presenterStack != null && presenterStack.count == 1 && presenterStack.peek() === this@AddCardWrapperPresenter) {
                    activity.finish()
                } else {
                    pop()
                }
                return false
            }
        }
        addEditPaymentCardFragment.setOnCXOCardAddedListener(listener)
        setFragment(addEditPaymentCardFragment)
    }

    override fun interceptBack(): Boolean {
        val handled = super.interceptBack()
        if (mFragment != null) {
            val fragmentManager = mFragment?.getCurrentFragmentManager()
            if (!handled && fragmentManager != null) {
                fragmentManager.popBackStack()
            }
        }
        return handled
    }
}
