package com.asda.android.app.dp.view

import android.view.Menu
import android.view.MenuInflater
import android.view.MenuItem
import androidx.appcompat.app.AppCompatActivity
import androidx.fragment.app.Fragment
import com.asda.android.R
import com.asda.android.app.account.view.AccountFragment
import com.asda.android.app.account.view.BaseAccountActivity
import com.asda.android.app.main.view.AsdaActivity
import com.asda.android.slots.subscription.view.DPOrderHistoryFragment

class ActiveDPTabbedFragment : DPTabbedBaseFragment() {

    override fun getFragmentTag(): String? {
        return TAG
    }

    override fun hasActionBar(): Boolean {
        val activity = activity
        return activity is AsdaActivity || activity is DeliveryPassPurchaseActivity || activity is BaseAccountActivity || parentFragment is AccountFragment
    }

    override fun getActionBarTitle(): String? {
        return if (activity != null) getString(R.string.delivery_pass) else ""
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        if (item.itemId == android.R.id.home) {
            pop()
            return true
        }
        return false
    }

    override fun getFragmentsForTabbedAdapter(): List<Pair<Fragment, String>> {
        // list of fragment and its title
        val fragments = mutableListOf<Pair<Fragment, String>>()
        fragments.add(Pair(ActiveDPFragment(), getString(R.string.active)))
        fragments.add(Pair(DPOrderHistoryFragment.newInstance(), getString(R.string.expired)))
        return fragments.toList()
    }

    companion object {
        const val TAG = "DPDetailsTabbedFragment"
        @JvmStatic
        fun newInstance() = ActiveDPTabbedFragment()
    }

    override fun onCreateOptionsMenu(menu: Menu, inflater: MenuInflater) {
        super.onCreateOptionsMenu(menu, inflater)
        setupActionBar()
    }

    override fun setupActionBar() {
        val actionBar = (activity as AppCompatActivity).supportActionBar
        actionBar?.title = getActionBarTitle()
    }
}
