package com.asda.android.app.dp.view

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import com.asda.android.R
import com.asda.android.base.core.view.fragments.BaseFragment
import com.asda.android.base.core.view.ui.gone
import com.google.android.material.tabs.TabLayoutMediator
import kotlinx.android.synthetic.main.fragment_dpdetails_tabbed.*

abstract class DPTabbedBaseFragment : BaseFragment() {

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        return inflater.inflate(R.layout.fragment_dpdetails_tabbed, container, false)
    }

    override fun getInternalTag(): String? {
        return getFragmentTag()
    }

    override fun popChildFragmentsOnViewCreated(): Boolean {
        return false
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        // add fragments
        val fragmentsList = getFragmentsForTabbedAdapter()
        addFragmentsToPager(fragmentsList)
        addFragmentsTitleToTabs(fragmentsList)
    }

    private fun addFragmentsToPager(fragmentsList: List<Pair<Fragment, String>>) {
        val fragmentsAdapter = DPTabbedFragmentsAdapter(this, fragmentsList)
        pager.adapter = fragmentsAdapter
    }

    private fun addFragmentsTitleToTabs(fragmentsList: List<Pair<Fragment, String>>) {

        val tabMediator = TabLayoutMediator(tab_layout, pager) { tab, position ->
            tab.text = fragmentsList[position].second
        }

        if (fragmentsList.size == 1) {
            tab_layout.gone()
            tabMediator.detach()
            return
        } else {
            tabMediator.attach()
        }
    }

    abstract fun getFragmentTag(): String?

    abstract fun getFragmentsForTabbedAdapter(): List<Pair<Fragment, String>>
}
