package com.asda.android.app.dp.view

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.asda.android.R
import com.asda.android.analytics.AsdaAnalyticsEvent
import com.asda.android.analytics.Tracker
import com.asda.android.analytics.constants.Anivia
import com.asda.android.base.core.view.ViewUtil
import com.asda.android.base.core.view.fragments.FeaturedFragment
import com.asda.android.restapi.utils.SharedPreferencesUtil
import kotlinx.android.synthetic.main.fragment_delivery_pass_benefits.*

class DeliveryPassBenefitsFragment : FeaturedFragment() {

    override fun onCreateView(
        inflater: LayoutInflater,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        return inflater.inflate(R.layout.fragment_delivery_pass_benefits, container, false)
    }

    override fun getActionBarTitle() = context?.getString(R.string.delivery_pass)

    override fun hasActionBar() = true

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        continue_button.setOnClickListener {
            push(ActiveDPTabbedFragment.newInstance())
        }
        tc_label.setOnClickListener {
            if (context != null) {
                ViewUtil.openWebPage(
                    SharedPreferencesUtil.getDPTermsAndConditionsUrl(context), context,
                    ActiveDPViewHandler.TAG
                )
            }
        }
        faq_label.setOnClickListener {
            context?.let {
                ViewUtil.openWebPage(
                    SharedPreferencesUtil.getDPFAQUrl(it),
                    it,
                    ActiveDPViewHandler.TAG
                )
                Tracker.get().trackEvent(
                    AsdaAnalyticsEvent(Anivia.DP_FAQ_EVENT)
                        .putString(Anivia.ENGAGEMENT_REPORT_KEY, "Delivery Pass : FAQ Views")
                )
            }
        }
    }
}
