package com.asda.android.app.main.helper

import io.reactivex.disposables.CompositeDisposable
import io.reactivex.disposables.Disposable

class AppDisposableHelper {
    private var compositeDisposable: CompositeDisposable? = null

    fun safeAdd(disposableObserver: Disposable) {
        if (compositeDisposable != null && !compositeDisposable!!.isDisposed) {
            compositeDisposable!!.add(disposableObserver)
        } else {
            compositeDisposable = CompositeDisposable()
            compositeDisposable!!.add(disposableObserver)
        }
    }

    fun safeDispose() {
        compositeDisposable?.let {
            if (!it.isDisposed) {
                it.clear()
                compositeDisposable = null
            }
        }
    }
}
