package com.asda.android.app.messagecenter

import android.os.Parcelable
import com.fasterxml.jackson.annotation.JsonIgnoreProperties
import com.fasterxml.jackson.annotation.JsonInclude
import com.fasterxml.jackson.annotation.JsonProperty
import kotlinx.android.parcel.Parcelize

@Parcelize
@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonIgnoreProperties(ignoreUnknown = true)
data class OSMReadMessageRequest(
    @JsonProperty("data")
    @get:JsonProperty("data")
    @set:JsonProperty("data")
    var data: ReadStateData? = null
) : Parcelable {
    @Parcelize
    @JsonIgnoreProperties(ignoreUnknown = true)
    data class ReadStateOsm(
        @JsonProperty("profile_id")
        @get:JsonProperty("profile_id")
        @set:JsonProperty("profile_id")
        var profileId: String? = null,
        @JsonProperty("messages")
        @get:JsonProperty("messages")
        @set:JsonProperty("messages")
        var messages: List<OSMRequestMessage>? = null
    ) : Parcelable

    @Parcelize
    @JsonIgnoreProperties(ignoreUnknown = true)
    data class ReadStateData(
        @JsonProperty("osm")
        @get:JsonProperty("osm")
        @set:JsonProperty("osm")
        var osm: ReadStateOsm? = null
    ) : Parcelable

    @Parcelize
    @JsonIgnoreProperties(ignoreUnknown = true)
    data class OSMRequestMessage(
        @JsonProperty("message_id")
        @get:JsonProperty("message_id")
        @set:JsonProperty("message_id")
        var messageId: String? = null,
        @JsonProperty("campaign_id")
        @get:JsonProperty("campaign_id")
        @set:JsonProperty("campaign_id")
        var campaignId: String? = null
    ) : Parcelable
}
