package com.asda.android.app.messagecenter.osm

import android.os.Parcelable
import com.fasterxml.jackson.annotation.JsonIgnoreProperties
import com.fasterxml.jackson.annotation.JsonProperty
import kotlinx.android.parcel.Parcelize

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class OSMGetMessagesResponse(
    @JsonProperty("data")
    var data: Data? = null,
    @JsonProperty("errors")
    var errors: List<Error>? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class OSMMessage(
    @JsonProperty("message_id")
    var messageId: String? = null,
    @JsonProperty("campaign_id")
    var campaignId: String? = null,
    @JsonProperty("updated_at")
    var updatedAt: String? = null,
    @JsonProperty("content")
    var content: String? = null,
    @JsonProperty("heading")
    var heading: String? = null,
    @JsonProperty("priority")
    var priority: String? = null,
    @JsonProperty("state")
    var state: String? = null,
    @JsonProperty("additional_infos")
    var additionalInfo: AdditionalInfo? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class Error(
    @JsonProperty("code")
    var code: String? = null,
    @JsonProperty("message")
    var meesage: String? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class AdditionalInfo(
    @JsonProperty("tag")
    var tag: String? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class Data(
    @JsonProperty("osm")
    var osm: GetOsm? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class GetOsm(
    @JsonProperty("unread_message_count")
    var unreadMessageCount: Int? = null,
    @JsonProperty("messages")
    var messages: List<OSMMessage>? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class DeleteOsmResponse(
    @JsonProperty("data")
    var data: DeleteData? = null,
    @JsonProperty("errors")
    var errors: List<Error>? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class DeleteOsm(
    @JsonProperty("message_id")
    var messageId: String? = null,
    @JsonProperty("state")
    var state: String? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class DeleteData(
    @JsonProperty("osm")
    var osm: DeleteOsm? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class ReadStatusOsmResponse(
    @JsonProperty("data")
    var data: PutData? = null,
    @JsonProperty("errors")
    var errors: List<Error>? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class PuttOsm(
    @JsonProperty("profile_id")
    var profileId: String? = null,
    @JsonProperty("messages")
    var messages: List<OSMMessage>? = null
) : Parcelable

@Parcelize
@JsonIgnoreProperties(ignoreUnknown = true)
data class PutData(
    @JsonProperty("osm")
    var osm: PuttOsm? = null
) : Parcelable
