package com.asda.android.app.messagecenter.osm.repo

import com.asda.android.app.messagecenter.OSMReadMessageRequest
import com.asda.android.app.messagecenter.osm.service.OSMServiceCreator

class OSMRepository {

    suspend fun fetchOSMMessages() = getService()?.getOSMMessages()
    suspend fun makeRead(request: OSMReadMessageRequest) = getService()?.updateReadStatus(request)
    suspend fun deleteMessage(messageId: String) = getService()?.deleteOSMMessage(messageId)

    fun getService() =
        OSMServiceCreator.getCreatedService()
}
