package com.asda.android.app.messagecenter.osm.service

import com.asda.android.app.messagecenter.OSMReadMessageRequest
import com.asda.android.app.messagecenter.osm.DeleteOsmResponse
import com.asda.android.app.messagecenter.osm.OSMGetMessagesResponse
import com.asda.android.app.messagecenter.osm.ReadStatusOsmResponse
import retrofit2.http.Body
import retrofit2.http.DELETE
import retrofit2.http.GET
import retrofit2.http.PUT
import retrofit2.http.Path

interface OSMMessageService {

    @GET("osm/messages")
    suspend fun getOSMMessages(): OSMGetMessagesResponse

    @DELETE("osm/messages/{id}")
    suspend fun deleteOSMMessage(@Path("id") messageId: String): DeleteOsmResponse

    @PUT("osm/messages")
    suspend fun updateReadStatus(@Body body: OSMReadMessageRequest): ReadStatusOsmResponse
}
