package com.asda.android.app.messagecenter.osm.usecase

import com.asda.android.app.messagecenter.osm.DeleteOsmResponse
import com.asda.android.app.messagecenter.osm.repo.OSMRepository
import com.asda.android.authorization.usecase.BaseUseCase
import com.asda.android.restapi.config.Result
import kotlinx.coroutines.CoroutineDispatcher

class DeleteOsmMessageUseCase(dispatcher: CoroutineDispatcher) :
    BaseUseCase<String, DeleteOsmResponse>(dispatcher) {

    val osmRepo = OSMRepository()

    override suspend fun execute(parameters: String) = osmRepo.deleteMessage(parameters)!!

    override suspend fun invoke(
        parameters: String,
        delayTime: Long,
        retryThreshold: Int
    ): Result<DeleteOsmResponse> {
        return superInvokeMethod(parameters, delayTime, retryThreshold)
    }

    suspend inline fun superInvokeMethod(
        parameters: String,
        delayTime: Long,
        retryThreshold: Int
    ) = super.invoke(parameters, delayTime, retryThreshold)
}
