package com.asda.android.app.messagecenter.osm.usecase

import androidx.annotation.VisibleForTesting
import com.asda.android.app.messagecenter.osm.OSMGetMessagesResponse
import com.asda.android.app.messagecenter.osm.repo.OSMRepository
import com.asda.android.authorization.usecase.BaseUseCase
import com.asda.android.restapi.config.Result
import kotlinx.coroutines.CoroutineDispatcher

class GetOsmMessagesUseCase(dispatcher: CoroutineDispatcher) :
    BaseUseCase<Any, OSMGetMessagesResponse>(dispatcher) {

    @VisibleForTesting
    val osmRepo = OSMRepository()

    override suspend fun execute(parameters: Any): OSMGetMessagesResponse =
        osmRepo.fetchOSMMessages()!!

    override suspend fun invoke(
        parameters: Any,
        delayTime: Long,
        retryThreshold: Int
    ): Result<OSMGetMessagesResponse> {
        return superInvokeMethod(parameters, delayTime, retryThreshold)
    }

    suspend inline fun superInvokeMethod(parameters: Any, delayTime: Long, retryThreshold: Int) =
        super.invoke(parameters, delayTime, retryThreshold)
}
