package com.asda.android.app.messagecenter.osm.usecase

import com.asda.android.app.messagecenter.OSMReadMessageRequest
import com.asda.android.app.messagecenter.osm.ReadStatusOsmResponse
import com.asda.android.app.messagecenter.osm.repo.OSMRepository
import com.asda.android.authorization.usecase.BaseUseCase
import com.asda.android.restapi.config.Result
import kotlinx.coroutines.CoroutineDispatcher

class MarkReadUseCase(dispatcher: CoroutineDispatcher) :
    BaseUseCase<OSMReadMessageRequest, ReadStatusOsmResponse>(dispatcher) {

    val osmRepo = OSMRepository()

    override suspend fun execute(parameters: OSMReadMessageRequest) = osmRepo.makeRead(parameters)!!

    override suspend fun invoke(
        parameters: OSMReadMessageRequest,
        delayTime: Long,
        retryThreshold: Int
    ): Result<ReadStatusOsmResponse> {
        return superInvokeMethod(parameters, delayTime, retryThreshold)
    }

    suspend inline fun superInvokeMethod(
        parameters: OSMReadMessageRequest,
        delayTime: Long,
        retryThreshold: Int
    ) = super.invoke(parameters, delayTime, retryThreshold)
}
