package com.asda.android.app.model

import android.content.Context
import android.location.Address
import android.net.ConnectivityManager

class AddressSearchResult(context: Context, addresses: List<Address?>?) {
    var address: Address? = null
    var error = 0

    fun hasAddress(): Boolean {
        return address != null
    }

    companion object {
        const val ERROR_NO_NETWORK = 1
        const val ERROR_SERVICE_UNAVAILABLE = 2
        const val ERROR_NO_ADDRESSES_FOUND = 3
    }

    init {
        if (addresses != null) {
            if (addresses.isEmpty()) {
                error = ERROR_NO_ADDRESSES_FOUND
            }
        } else {
            val cm = context.getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager
            val networkInfo = cm.activeNetworkInfo
            error = if (networkInfo == null || !networkInfo.isConnected) {
                ERROR_NO_NETWORK
            } else {
                ERROR_SERVICE_UNAVAILABLE
            }
        }
        if (error == 0) {
            var firstUSAddress: Address? = null
            addresses?.forEach { address ->
                firstUSAddress = address
                if ("US" == firstUSAddress?.countryCode) {
                    return@forEach
                }
            }
            address = firstUSAddress
        }
    }
}
