package com.asda.android.app.model

import android.app.Notification
import android.app.PendingIntent
import android.content.Context
import android.content.Intent
import com.asda.android.R
import com.asda.android.analytics.AsdaAnalyticsEvent
import com.asda.android.analytics.Tracker
import com.asda.android.analytics.constants.Anivia
import com.asda.android.app.lastmile.EXTRA_MESSAGE_CUSTOMER_ID
import com.asda.android.app.lastmile.EXTRA_MESSAGE_ORDERID
import com.asda.android.app.lastmile.LMDetailsActivity
import com.asda.android.app.main.view.AsdaActivity
import com.asda.android.lastmile.view.LastMileNotificationFactory

fun createCheckinNotification(context: Context): Notification {
    val intent = Intent(context, AsdaActivity::class.java)
    val pendingIntent = PendingIntent.getActivity(context, 0, intent, PendingIntent.FLAG_UPDATE_CURRENT)
    return LastMileNotificationFactory.createCheckInNotification(
        context,
        context.getString(R.string.checkin_order_title), pendingIntent
    )
}

@Suppress("UNUSED_PARAMETER")
fun logAnalyticsForCheckinSuccess(customerId: String, orderId: String, storeId: String, initialTimeInSec: String, initialDistance: String) {
    val event = AsdaAnalyticsEvent(Anivia.CHECKIN_SUCCESS_EVENT)
    event.updateTimestamp()
    event.putString(Anivia.COLLECTION_STORE_ID_KEY, storeId)
        .putString(Anivia.CUSTOMER_ID_KEY, customerId)
        .putString(Anivia.ORDER_ID_KEY, orderId)
        .putString(Anivia.CHECKIN_STATUS, "yes")
    Tracker.get().trackEvent(event)
}

fun createLMActivity(context: Context, orderId: String, customerId: String) {
    val intent = Intent(context, LMDetailsActivity::class.java)
    intent.putExtra(EXTRA_MESSAGE_ORDERID, orderId)
    intent.putExtra(EXTRA_MESSAGE_CUSTOMER_ID, customerId)
    context.startActivity(intent)
}
