package com.asda.android.app.orders.ods

import com.asda.android.orders.constants.ODS_ENDPOINT
import com.asda.android.orders.constants.PROD_ENDPOINT
import okhttp3.Interceptor
import okhttp3.Response

class OdsInterceptor : Interceptor {
    override fun intercept(chain: Interceptor.Chain): Response {
        var originalRequest = chain.request()
        val requestBuilder = originalRequest.newBuilder()
        val requestUrl = originalRequest.url().toString()
        addAuthenticationToken(requestUrl, requestBuilder)
        if (requestUrl.contains("orders-lookup/services/v4/")) {
            requestBuilder.addHeader("Content-Type", "application/json")
            requestBuilder.addHeader("ACCEPT", "application/json")
            requestBuilder.addHeader("WM_CONSUMER.TENANT_ID", "5")
            if (requestUrl.contains(PROD_ENDPOINT)) {
                requestBuilder.addHeader("WM_SVC.ENV", "prod")
            } else {
                requestBuilder.addHeader("WM_SVC.ENV", "qa-int:4.0.0")
            }
            requestBuilder.addHeader("WM_SVC.NAME", "ASDA-ORDER-SERVICE")
            if (requestUrl.contains(ODS_ENDPOINT))
                requestBuilder.addHeader("WM_SVC.VERSION", "6.0.0")

            if (requestUrl.contains("/orders-service/orders")) {
                requestBuilder.addHeader("SKIP_USER_ID_CHECK", "false")
            } else {
                addAuthenticationToken(requestBuilder)
            }
        }
        originalRequest = requestBuilder.build()
        return chain.proceed(originalRequest)
    }
}
