package com.asda.android.app.orders.ods

import com.asda.android.base.interfaces.IOrderUtilsManager
import com.asda.android.restapi.service.data.OdsOrderModel
import com.asda.android.restapi.service.data.ViewOrderResponse
import com.asda.android.service.base.OrderManager

class OrderUtilsManager : IOrderUtilsManager {
    override fun mapOrderNetworkToViewOrder(odsOrderModel: OdsOrderModel, pageNum: Int): ViewOrderResponse = mapOdsHistoryToViewOrder(odsOrderModel, pageNum)
    override fun setUpCNCBannerCallback(flagUser: (Boolean) -> Unit) {
        val orderManagerCallback = object : OrderManager.Callback {
            override fun onFinished(total: Int, pending: Int, orders: List<ViewOrderResponse.Order>?, processedOrders: List<ViewOrderResponse.Order>?) {
                val newUser = total == 0 && pending == 0
                flagUser(newUser)
            }

            override fun onFailed() {
                // no need to handle on failed
            }
        }
        OrderManager.get().fetchOrders(orderManagerCallback)
    }
}
