package com.asda.android.app.orders.view

import android.app.Activity
import android.content.Context
import com.asda.android.app.bookslotv3.view.activity.DeliveryImpactActivity
import com.asda.android.app.orders.ods.getDeliveryImpactFragmentTag
import com.asda.android.base.core.constants.ActivityRequestCodes
import com.asda.android.cxo.deliveryimpact.view.fragment.PREVIEW_AMEND
import com.asda.android.orders.constants.AMEND_OPERATION
import com.asda.android.orders.wismo.constants.WismoCardConstants
import com.asda.android.restapi.service.data.ViewOrderResponse
import com.asda.android.restapi.service.data.cart.CartResponse

object OrderViewUtils {
    fun showPreviewAmendScreen(context: Context, cartResponse: CartResponse?, amendOperation: String, orderToBeAmended: ViewOrderResponse.Order?) {
        val intent = DeliveryImpactActivity.newIntent(context, cartResponse?.data?.cart?.changesToPreview, getDeliveryImpactFragmentTag(cartResponse))
        intent.putExtra(PREVIEW_AMEND, true)
        intent.putExtra(WismoCardConstants.ORDER_TO_BE_AMENDED, orderToBeAmended)
        intent.putExtra(AMEND_OPERATION, amendOperation)
        (context as Activity).startActivityForResult(intent, ActivityRequestCodes.REQUEST_CODE_PREVIEW_AMEND)
    }
}
