package com.asda.android.app.settings

import android.content.Context
import com.asda.android.app.settings.featureflag.FeatureSettings
import com.asda.android.authorization.BootstrapManager
import com.asda.android.featureGen._Feature_Settings
import com.asda.android.restapi.interfaces.IFeatureSettingManager

object FeatureSettingManager : IFeatureSettingManager {

    override fun isAllOffersP13NEnabled(context: Context): Boolean {
        return FeatureSettings.isAllOffersP13NEnabled(context)
    }

    override fun isRelatedSearchesEnabled(context: Context): Boolean {
        return FeatureSettings.isRelatedSearchesEnabled(context)
    }

    override fun isBottomNavOrderTestEnabled(context: Context): Boolean {
        return FeatureSettings.isBottomNavOrderTestEnabled(context)
    }

    override fun isStoreIdForListDpEnabled(context: Context): Boolean {
        return FeatureSettings.isStoreIdForListDpEnabled(context)
    }

    override fun isSubscriptionAPIEnabled(context: Context): Boolean {
        return FeatureSettings.isSubscriptionAPIEnabled(context)
    }

    override fun isEGiftCardEnabled(context: Context): Boolean =
        FeatureSettings.isEGiftCardsEnabled(context)

    override fun isAdsDecisionEngineEnabled(context: Context) =
        FeatureSettings.isAdsDecisionEngineEnabled(context)

    override fun isSolrEACEngineEnabled(context: Context): Boolean {
        return FeatureSettings.isSolrEACEngineEnabled(context)
    }

    override fun isOffersForYouEnabled(context: Context): Boolean {
        return FeatureSettings.isOffersForYouEnabled(context)
    }

    override fun isThreedsEnabledForDp(context: Context): Boolean {
        return FeatureSettings.isThreedsEnabledForDp(context)
    }

    override fun isThreedsEnabledForEditDp(context: Context): Boolean {
        return FeatureSettings.isThreedsEnabledForEditDp(context)
    }

    override fun isThreedsEnabledAmex(context: Context): Boolean {
        return FeatureSettings.isThreedsEnabledAmex(context)
    }

    override fun isDeliveryPassBlocked(context: Context): Boolean {
        return FeatureSettings.isDeliveryPassBlocked(context)
    }

    override fun isRmpEnabled(context: Context) = FeatureSettings.isRmpIntegrationEnabled(context)

    override fun isSingleProfileIdCheckinEnabled(context: Context) =
        FeatureSettings.isSingleProfileIdCheckinEnabled(context)

    override fun isBFFBootstrapEnabled(context: Context) =
        FeatureSettings.isBFFBootstrapEnabled(context)

    override fun isNewPageTypeAllOffersEnabled(context: Context): Boolean =
        FeatureSettings.isAllOffersPageNewType(context)
    override fun isNewHomePageEnabled(context: Context): Boolean = FeatureSettings.isNewHomePageEnable(context)
    override fun isCardinalSessionUITypeHTMLEnable(context: Context): Boolean =
        FeatureSettings.isCardinalSessionUITypeHTMLEnable(
            context
        )

    override fun isDynamicElementOnStaticAdEnabled(context: Context) =
        FeatureSettings.isDynamicElementEnableOnStaticAds(context)

    override fun isSlotSecondaryStoreEnabled(context: Context) =
        FeatureSettings.isSlotSecondaryStoreEnabled(context)

    override fun isSlotsDateTimeAddressForReservedStatusEnabled(context: Context) =
        FeatureSettings.isSlotsDateTimeAddressForReservedStatusEnabled(context)

    override fun isExpressHDEnabled(context: Context): Boolean =
        FeatureSettings.isExpressHDEnabled(context)

    override fun isSearchExpEnabled(context: Context): Boolean = FeatureSettings.isSearchExpEnabled(context)

    override fun isHooklogicOnNewFavoritesEnabled(context: Context): Boolean = FeatureSettings.isHooklogicOnNewFavoritesEnabled(context)

    override fun isP13nUserSegEnabled(context: Context): Boolean = FeatureSettings.isP13NUserSegmentsEnabled(context)

    override fun isEGiftCardSSOEnabled(context: Context): Boolean = _Feature_Settings.isEgiftCardSSSOEnableEnabled(context)

    override fun isYourRegularsEnabled(context: Context): Boolean {
        return _Feature_Settings.isYourRegularsEnabled(context) && (
            "variantA".equals(BootstrapManager.getExperimentConfig().isYourRegularsEnabled) ||
                "variantB".equals(BootstrapManager.getExperimentConfig().isYourRegularsEnabled)
            )
    }
    override fun isSponsoredDedupeEnabled(context: Context) =
        _Feature_Settings.isHooklogicDedupeEnabledEnabled(context)

    override fun isSearchInGridEnabled(context: Context): Boolean = _Feature_Settings.isM10ExperimentSearchEnabledEnabled(context)

    override fun isMobileAppPreviewEnabled(context: Context): Boolean = _Feature_Settings.isMobileAppPreviewEnabled(context)

    override fun isYourReturnsPageEnabled(context: Context) = _Feature_Settings.isYourRefundsPageEnabled(context)

    override fun isInAppReportingEnabled(context: Context) = _Feature_Settings.isInAppReportingEnabled(context)

    override fun isNewTaxonomyEnabled(context: Context) = _Feature_Settings.isNewTaxonomyEnabledEnabled(context)

    override fun isRecurringSlotEnabledForPayg(context: Context) = _Feature_Settings.isRecurringSlotForPaygEnabled(context)

    override fun isPersonalisedSampleEnabled(context: Context) = _Feature_Settings.isPersonalisedSamplesEnabledEnabled(context)

    override fun isRefundMethodPageEnabled(context: Context) = _Feature_Settings.isChooseRefundMethodPageEnabled(context)
}
