package com.asda.android.app.settings.featureflag.view.flags

import com.asda.android.annotations.FeatureFlag
import com.asda.android.restapi.service.data.bootstrap.ExperimentConfig

@FeatureFlag(
    stringResFeature = "debug_settings_is_egift_card_sso_enabled",
    firebaseFlagRes = "isEGiftCardSSOEnabled"
)
class EgiftCardSSSOEnable

@FeatureFlag(
    stringResFeature = "debug_settings_hook_logic_dedupe",
    firebaseFlagRes = "isHooklogicDedupeEnabled",
    defSharedPrefVal = true
)
class HooklogicDedupeEnabled

@FeatureFlag(
    stringResFeature = "debug_settings_is_your_regulars_enabled",
    firebaseFlagRes = "isYourRegularsEnabled",
    shouldReboot = true
)
class YourRegulars

@FeatureFlag(
    stringResFeature = "debug_is_m10_experiment_enabled",
    firebaseFlagRes = "isM10nSearchInGridExpEnabled",
    defSharedPrefVal = true,
    selectedIndex = 1
)
class M10ExperimentSearchEnabled

@FeatureFlag(
    stringResFeature = "debug_m_app_preview",
    firebaseFlagRes = "isMobilePreviewEnabled",
    defSharedPrefVal = true,
    selectedIndex = 1
)
class MobileAppPreview

@FeatureFlag(
    stringResFeature = "debug_is_your_returns_page_enabled",
    firebaseFlagRes = "isYourReturnsPageEnabled",
    defSharedPrefVal = true
)
class YourRefundsPage

@FeatureFlag(
    stringResFeature = "debug_in_app_reporting_enabled",
    firebaseFlagRes = "isInAppReportingEnabled",
    defSharedPrefVal = true
)
class InAppReporting

@FeatureFlag(
    stringResFeature = "debug_new_taxonomy_enabled",
    firebaseFlagRes = "isNewTaxonomyEnabled",
    defSharedPrefVal = false
)
class NewTaxonomyEnabled

@FeatureFlag(
    stringResFeature = "debug_is_rec_slot_for_payg_enabled",
    firebaseFlagRes = "isRecurringSlotEnabledForPayg",
    defSharedPrefVal = false
)
class RecurringSlotForPayg

@FeatureFlag(
    stringResFeature = "debug_settings_personalised_sample",
    firebaseFlagRes = "isPersonalisedSampleEnabled",
    experimentKey = "isPersonalisedSampleEnabled",
    siteConfigs = ExperimentConfig::class,
    defSharedPrefVal = false
)
class PersonalisedSamplesEnabled

@FeatureFlag(
    stringResFeature = "debug_is_refund_method_page_enabled",
    firebaseFlagRes = "isRefundMethodPageEnabled",
    experimentKey = "isRefundMethodPageEnabled",
    siteConfigs = ExperimentConfig::class,
    defSharedPrefVal = false
)
class ChooseRefundMethodPage
