package com.asda.android.app.shop

import android.content.Context
import androidx.fragment.app.Fragment
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.asda.android.base.core.utils.tryCast
import com.asda.android.base.core.view.adapter.WIDTH_NONE
import com.asda.android.base.interfaces.InterfaceAdapterProvider
import com.asda.android.products.ui.product.helper.ProductSpanSizeLookup
import com.asda.android.products.ui.product.model.ProductViewInfoModel
import com.asda.android.products.ui.product.tile.view.ProductTileGroupAdapter

class ProductAdapterProvider : InterfaceAdapterProvider {
    override fun getProductAdapter(sourceFragment: Fragment, context: Context, additionalInfoMap: MutableMap<String, Any?>): RecyclerView.Adapter<in RecyclerView.ViewHolder> = ProductTileGroupAdapter(sourceFragment, context, WIDTH_NONE, mutableListOf(), ProductViewInfoModel(), additionalInfoMap)
    override fun updateAndGetProductSpanSizeLookUp(spanSizeLookup: GridLayoutManager.SpanSizeLookup, removeFirst: Boolean): GridLayoutManager.SpanSizeLookup? {
        spanSizeLookup.tryCast<ProductSpanSizeLookup> {
            return this.updateAndGet(removeFirst)
        }
        return null
    }

    override fun setUpSortFilterAnalytics(recyclerView: RecyclerView, filterApplied: String, sortApplied: String) {
        recyclerView.adapter?.tryCast<ProductTileGroupAdapter> {
            notifySortFilterAnalytics(filterApplied, sortApplied)
        }
    }
}
