package com.asda.android.app.shop.addtotrolley.repository

import androidx.lifecycle.MutableLiveData
import com.asda.android.base.core.response.BaseStateResponse
import com.asda.android.cxo.utils.CartRepository
import com.asda.android.restapi.service.data.cart.CartResponse
import io.reactivex.SingleObserver
import io.reactivex.disposables.Disposable

class AddToTrolleyRepository {

    private val cartResponseLiveData: MutableLiveData<BaseStateResponse<CartResponse>> = MutableLiveData()

    val location = "Shopping Lists"
    fun addUpdateCart(cartRepository: CartRepository, items: ArrayList<Any>) {
        cartRepository.addUpdateShoppingList(items, location)
            ?.subscribe(object : SingleObserver<Any> {
                override fun onSuccess(t: Any) {
                    getCartResponse().postValue(BaseStateResponse(t as CartResponse))
                }

                override fun onSubscribe(d: Disposable) {
                    // This method is not implemented as there is no operation to be performed in onSubscribe()
                }

                override fun onError(e: Throwable) {
                    getCartResponse().postValue(BaseStateResponse(e))
                }
            })
    }

    fun getCartResponse(): MutableLiveData<BaseStateResponse<CartResponse>> {
        return cartResponseLiveData
    }
}
