package com.asda.android.app.shoppinglists

import android.annotation.SuppressLint
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.asda.android.R
import com.asda.android.app.main.view.AsdaActivity
import com.asda.android.base.core.view.fragments.FeaturedFragment
import com.asda.android.base.interfaces.IBaseFragment
import com.asda.android.base.interfaces.TransitionListener

class ShoppingListContainerFragment : FeaturedFragment() {

    @SuppressLint("MissingSuperCall") // Some code is still shared with presenters like BreadcrumbsFragment
    override fun onCreateView(
        inflater: LayoutInflater,
        fragmentContainer: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        return inflater.inflate(R.layout.container_fragment, fragmentContainer, false)
    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        val fragment = ShoppingListHomeFragment()
        fragment.transitionListener = object : TransitionListener {
            override fun onPushed(fragment: IBaseFragment, addToBackStack: Boolean): Boolean {
                return false
            }

            override fun onPopped(tag: String?): Boolean {
                if (activity is AsdaActivity) {
                    val fragmentSwitcher = (activity as AsdaActivity).getFragmentSwitcher()
                    if (fragmentSwitcher != null) {
                        return fragmentSwitcher.onBackPressed()
                    }
                }
                return false
            }
        }
        pushNoAnimation(fragment, true)
    }

    override fun isParentFragment(): Boolean {
        return true
    }
}
