package com.asda.android.app.storelocator.constants

import com.asda.android.app.storelocator.StoresFilterManager
import java.util.*
import java.util.regex.Pattern

object StoreLocatorConstants {
    val sActiveFilters = ArrayList<StoresFilterManager.Filter>()
    val petrolStationFilter = StoresFilterManager.Filter("Petrol Station")
    val filters = arrayOf(
        StoresFilterManager.Filter("24 Hour"), // 1
        StoresFilterManager.Filter("Pharmacy"), // 19
        petrolStationFilter, // 18
        StoresFilterManager.Filter("Opticians"), // 17
        StoresFilterManager.Filter("George"), // 15
        StoresFilterManager.Filter("Baby Changing"), // 13
        StoresFilterManager.Filter("Photo Department"), // 20
        StoresFilterManager.Filter("Click & Collect"), // 35
        StoresFilterManager.Filter("Travel Money"), // 34
        StoresFilterManager.Filter("Trade-in Games"), // 36
        StoresFilterManager.Filter("Electric Car Charging")
    )
    const val ASDA_REFERRER = "ASDA_Android_storefinder"
    const val UK = "uk"
    const val DATABASE_NAME = "recent_stores.db"
    const val STORE_TYPE = 0
    const val PLEASE_WAIT_TYPE = 1
    const val LOADING_TYPE = 2
    val locationHelperPrefs: String? = null
    const val PREF_NETWORK_DIALOG_SHOWN = "network_dialog"
    const val TIMEOUT: Long = 15000
    const val DEFAULT_MAX_RADIUS = 500
    const val DEFAULT_STORES_IN_VIEW = 6
    const val NOW_CLOSE = "Now closed"
    const val REG_EXP_OPENS = "(^Opens\\D*)(.*$)"
    val patternOpens = Pattern.compile(REG_EXP_OPENS)
    const val GROUP_OPENS_TIME = 2
    const val REG_EXP_CLOSES = "(^Closes\\D*)(.*$)"
    val patternCloses = Pattern.compile(REG_EXP_CLOSES)
    const val GROUP_CLOSES_TIME = 2
    const val ANIMATION_DURATION = 200
    const val REQUEST_CODE_LOCATION_RESOLUTION = 1
    const val FILTER_DIALOG = 1
    const val FINDING_MY_LOCATION_DIALOG = 2
    const val SEARCHING_DIALOG = 3
    const val FILTER_NOT_APPLIED_DIALOG = 4
    const val SEARCHING_LOCATION_DIALOG = 5
    const val COULD_NOT_FIND_STORES_DIALOG = 7
    const val UNKNOWN_ERROR_DIALOG = 9
    const val NO_STORES_WITH_SHIPPING_OPTIONS_DIALOG = 11
    const val LOADING_STORES_MAP_SPINNER_VIEW = "LOADING_STORES_MAP_SPINNER_VIEW_TAG"
    const val CENTER_THRESHOLD = 0.5

    // Store finder related
    const val DIALOG_LOCATION_SERVICE_FAILED = 100
    const val DIALOG_COULD_NOT_FIND_LOCATION = 101
    const val DIALOG_LOCATION_FIX_TIMED_OUT_USE_SEARCH = 102
    const val DIALOG_ERROR_NO_NETWORK = 600
    const val EXTRA_STORE_ID = "store_id"
}
