package com.asda.android.app.view

import android.os.Bundle
import android.view.LayoutInflater
import android.view.MenuItem
import android.view.View
import android.view.ViewGroup
import com.asda.android.R
import com.asda.android.app.main.view.AsdaActivity
import com.asda.android.base.core.constants.BottomNavConstants
import com.asda.android.base.core.constants.BottomNavConstants.TAG_SHOP_OLD
import com.asda.android.base.core.constants.ShopConstants
import com.asda.android.base.core.search.view.SearchableFragment
import com.asda.android.base.core.utils.AsdaBaseCoreConfig
import com.asda.android.restapi.search.model.AsdaSearchData

class BaseSearchFragment : SearchableFragment() {
    var currentView: View? = null

    override fun onCreateView(inflater: LayoutInflater, fragmentContainer: ViewGroup?, savedInstanceState: Bundle?): View {
        if (currentView == null) {
            currentView = inflater.inflate(R.layout.no_content_container, fragmentContainer, false)
        }
        return currentView!!
    }

    override fun onSearchRequested(searchData: AsdaSearchData?) {
        super.onSearchRequested(searchData)
        popToRoot()
        val bundle = Bundle().apply {
            putParcelable(ShopConstants.ARG_SEARCH_DATA, searchData)
        }
        (activity as? AsdaActivity)?.let {
            if (AsdaBaseCoreConfig.featureSettingManager.isNewTaxonomyEnabled(it.applicationContext)) {
                it.getFragmentSwitcher()?.switchToFragment(BottomNavConstants.TAG_SHOP, bundle)
            } else {
                it.getFragmentSwitcher()?.switchToFragment(TAG_SHOP_OLD, bundle)
            }
        }
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        finishSearchAction()
        return super.onOptionsItemSelected(item)
    }

    override fun onBackPressed(): Boolean {
        finishSearchAction()
        return super.onBackPressed()
    }
}
