package com.asda.android.app.view

import android.app.Activity
import android.content.Context
import android.os.Bundle
import com.asda.android.R
import com.asda.android.app.main.view.AsdaActivity
import com.asda.android.app.shop.BarcodeScanActivity
import com.asda.android.base.core.constants.ActivityRequestCodes
import com.asda.android.base.interfaces.IMainController
import com.asda.android.utils.view.startOnTrolleyModify

object MainController : IMainController {
    override fun startOnTrolleyUpdate(activity: Activity, origin: String, bundle: Bundle) {
        startOnTrolleyModify(activity, origin, bundle)
    }
    override fun getBottomNavBarId(): Int {
        return R.id.bottom_nav_bar
    }

    override fun getRootLayoutId(): Int {
        return R.id.root_layout
    }

    override fun getSearchId(): Int {
        return R.id.action_search
    }

    override fun canScanBarcode(context: Context?): Boolean {
        return BarcodeScanActivity.canScanBarcode(context)
    }

    override fun getMainActivityClass(): Class<*> {
        return AsdaActivity::class.java
    }
    override fun launchBarcodeScanner(activity: Activity?) {
        BarcodeScanActivity.start(activity, ActivityRequestCodes.REQUEST_CODE_BARCODE_SCAN)
    }
}
