package com.asda.android.service.base

import com.asda.android.analytics.Tracker
import com.asda.android.analytics.events.exception.UnCaughtExceptionEvent
import java.lang.Thread.UncaughtExceptionHandler

object ExceptionHandler {
    private var isInitialized = false

    @JvmStatic
    fun initUncaughtExceptionHandler() {
        if (!isInitialized) {
            isInitialized = true
            val defaultHandler = Thread.currentThread().uncaughtExceptionHandler
            Thread.currentThread().uncaughtExceptionHandler = UncaughtExceptionHandler { thread: Thread?, ex: Throwable? ->
                Tracker.get().trackException(UnCaughtExceptionEvent(ex))
                if (thread != null && ex != null)
                    defaultHandler?.uncaughtException(thread, ex)
            }
        }
    }
}
