package com.asda.android.service.constants.module

import android.app.Application
import com.asda.android.analytics.Tracker
import com.asda.android.analytics.interfaces.ITracker
import com.asda.android.restapi.service.base.IAuthentication
import com.asda.android.service.base.Authentication
import dagger.Module
import dagger.Provides
import javax.inject.Singleton

@Module
class AuthenticationModule {
    @Provides
    @Singleton
    fun providesAuthentication(application: Application): IAuthentication {
        if (isAuthenticationInitialized().not()) {
            sAuthentication = Authentication(application.applicationContext)
        }
        return sAuthentication
    }

    @Provides
    @Singleton
    fun providesTracker(): ITracker {
        if (isTrackerInitialized().not()) {
            sTracker = Tracker.get()
        }
        return sTracker
    }

    companion object {
        lateinit var sAuthentication: Authentication
        lateinit var sTracker: Tracker
        private fun isTrackerInitialized() = ::sTracker.isInitialized
        private fun isAuthenticationInitialized() = ::sAuthentication.isInitialized
    }
}
