package com.asda.android.service.constants.module

import com.asda.android.service.base.OrderManager
import dagger.Module
import dagger.Provides
import javax.inject.Singleton

@Module
class OrderModule {
    @Provides
    @Singleton
    fun providesOrderManager(): OrderManager {
        if (isInitialized().not()) {
            sOrderManager = OrderManager()
        }
        return sOrderManager
    }

    companion object {
        lateinit var sOrderManager: OrderManager
        private fun isInitialized() = ::sOrderManager.isInitialized
    }
}
