package com.asda.android.utils.view

import android.content.res.AssetManager
import android.graphics.Typeface
import android.util.Log
import com.asda.android.app.main.AsdaApplication
import java.util.*

class FontManager private constructor(private val mAssetManager: AssetManager) {
    private val mFonts: MutableMap<String, Typeface?>
    fun getFont(asset: String): Typeface? {
        var font: Typeface? = null
        if (mFonts.containsKey(asset)) {
            font = mFonts[asset]
        }
        if (font == null) {
            try {
                font = Typeface.createFromAsset(mAssetManager, asset)
                mFonts[asset] = font
            } catch (t: Exception) {
                Log.w(TAG, "Error reading font asset", t)
            }
        }
        return font
    }

    companion object {
        private const val TAG = "FontManager"
        private var sInstance: FontManager? = null

        @JvmStatic
        val instance: FontManager?
            get() {
                if (sInstance == null) {
                    sInstance = FontManager(AsdaApplication.getComponent().application.assets)
                }
                return sInstance
            }
    }

    init {
        mFonts = HashMap()
    }
}
